package org.apache.bcel.classfile;

import org.apache.bcel.Const;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.DataInput;

public final class Deprecated extends Attribute
{
    private byte[] bytes;
    
    public Deprecated(final Deprecated c) {
        this(c.getNameIndex(), c.getLength(), c.getBytes(), c.getConstantPool());
    }
    
    public Deprecated(final int nameIndex, final int length, final byte[] bytes, final ConstantPool constantPool) {
        super((byte)8, nameIndex, length, constantPool);
        this.bytes = bytes;
    }
    
    Deprecated(final int nameIndex, final int length, final DataInput input, final ConstantPool constantPool) throws IOException {
        this(nameIndex, length, (byte[])null, constantPool);
        if (length > 0) {
            input.readFully(this.bytes = new byte[length]);
            Attribute.println("Deprecated attribute with length > 0");
        }
    }
    
    @Override
    public void accept(final Visitor v) {
        v.visitDeprecated(this);
    }
    
    @Override
    public Attribute copy(final ConstantPool constantPool) {
        final Deprecated c = (Deprecated)this.clone();
        if (this.bytes != null) {
            c.bytes = this.bytes.clone();
        }
        c.setConstantPool(constantPool);
        return c;
    }
    
    @Override
    public void dump(final DataOutputStream file) throws IOException {
        super.dump(file);
        if (super.getLength() > 0) {
            file.write(this.bytes, 0, super.getLength());
        }
    }
    
    public byte[] getBytes() {
        return this.bytes;
    }
    
    public void setBytes(final byte[] bytes) {
        this.bytes = bytes;
    }
    
    @Override
    public String toString() {
        return Const.getAttributeName(8) + ": true";
    }
}
